import { CloseEvent, ErrorEvent, MessageEvent, OpenEvent } from 'ws';
/**
 * @author Onur Gürsoy
 */
export declare class WebsocketClient {
    debug: boolean;
    readonly reconnectInterval = 1000;
    readonly timeoutInterval = 2000;
    readyState: number;
    private forcedClose;
    private timedOut;
    private readonly protocols;
    private webSocket?;
    private readonly url;
    static readonly debugAll = false;
    onopen: (ev: OpenEvent) => void;
    onclose: (ev: CloseEvent) => void;
    onconnecting: () => void;
    onmessage: (ev: MessageEvent) => void;
    onerror: (ev: ErrorEvent) => void;
    constructor(url: string, protocols?: string[]);
    connect(reconnectAttempt: boolean): void;
    send(data: string): void;
    /**
     * Returns boolean, whether websocket was FORCEFULLY closed.
     */
    close(): boolean;
    /**
     * Additional public API method to refresh the connection if still open (close, re-open).
     * For example, if the app suspects bad data / missed heart beats, it can try to refresh.
     *
     * Returns boolean, whether websocket was closed.
     */
    refresh(): boolean;
    private log;
}
